<template>
  <dibs-layout ref="layout" page="3a" layout="two-columns" :video="video">
    <template #aside-header
      ><div />
      <dibs-elem-lang-dropdown
    /></template>
    <template #aside-title>
      <!-- eslint-disable-next-line vue/no-v-html -->
      <h1 v-html="$t('page.3a.title')" />
    </template>
    <template #content>
      <dibs-form-elem
        v-if="banks"
        :label="$t('page.3a.form.label')"
        name="lpp"
        hint="<ul>
        <li>Hypothekarbank :
          <ul>
            <li><pre>alice / any text</pre></li>
            <li><pre>beatrice / any text</pre></li>
            <li><pre>dan / any text</pre></li>
          </ul>
        </li>
      </ul>"
      >
        <dibs-form-row :element-count="1" :has-ending="true">
          <dibs-input-select-search
            id="pv"
            v-model="pv"
            :default="pv"
            :options="Object.values(banks)"
            label="name"
          />
          <dibs-input-help @click="$refs['modal-pv'].open()">
            {{ $t("commons.where_to_find") }}
          </dibs-input-help>
        </dibs-form-row>
      </dibs-form-elem>

      <dibs-elem-btn
        :label="$t('page.3a.action')"
        picto="forward"
        :disabled="!formIsOk"
        @click="onSave"
      />
      <dibs-modal ref="modal-pv">
        <template #title>{{ $t("page.3a.modal.title") }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.3a.modal.content')" />
        </template>
      </dibs-modal>
    </template>
  </dibs-layout>
</template>

<script>
definePageMeta({
  middleware: ["if-not-authenticated-then-index"],
});

export default {
  name: "IndexPage",
  layout: "dibs",
  data() {
    return {
      mode: this.$route.query.mode,
      video: this.$tm("page.3a.video"),
      loaded: false,
      form: {
        solde: 0,
        amount: 0,
        rate: null,
        paydate: null,
      },
      banks: null,
      pv: null,
      grantingWindow: null,
      grantingOk: false,
    };
  },
  computed: {
    formIsOk() {
      return !!this.pv;
    },
  },
  mounted() {
    this.$models.Loader().on();
    this.init();
  },
  methods: {
    init() {
      window.addEventListener(
        "message",
        (msg) => {
          if (!this.grantingWindow) {
            return;
          }
          const data = msg.data;
          if (data === "grant-is-okay") {
            this.$models.Loader().on();
            msg.source.close();
            this.grantingOk = true;
            this.getProvident();
          }
        },
        false,
      );

      this.$models
        .OpenPV()
        .getRegistry()
        .then((registry) => {
          this.$models
            .OpenPV()
            .getSelection()
            .then((ids) => {
              if (ids && ids[0]) {
                this.pv = Object.assign({}, registry[ids[0]]);
              }
            })
            .finally(() => {
              this.banks = registry;
              this.$models.Loader().off();
            });
        })
        .catch(() => {
          this.$models.Loader().off();
        });
    },
    getProvident() {
      this.$models
        .OpenPV()
        .getProvident()
        .then(() => {
          this.$router.push(this.localePath("/synthesis"));
        })
        .catch(() => {
          this.$models.Loader().off();
          alert("Erreur lors de la récupération de vos données");
        });
    },
    onSave() {
      this.$models.Loader().on();
      this.grantingOk = false;
      this.$models
        .OpenPV()
        .saveSelection([this.pv.id])
        .then(() => {
          this.startGranting();
        })
        .catch(() => {
          this.$models.Loader().off();
          this.$refs.layout.loadMe(true);
        });
    },
    startGranting() {
      window.open(
        this.$config.public.dibsApiBasePath + "/openpv/user/tokens",
        "_blank",
      );
      this.grantingWindow = true;
      this.$models.Loader().off();
    },
  },
};
</script>
